--   **********************************************************************************
--                                  Update Log
-- ********************************************************************************
-- 20100907 Finally!!! the computer had an OS update pending. Guess this is why the 
--          Synthesis kept generating faulty configuration files.
-- 20100907 passed syntax check, but the program doesn't work
-- 20100907 Decided last night to implement block RAM based sinusoidal lookup table
--          Seen in ChipScope that the distributed RAM used by the legacy design is 
--          in fact using more than 70% of the resource. 
-- 20100904 Trying to separate the AWG module away from everything else. This helps
--          In debugging.
-- 20100822 May want to do this: reduce the number of buffers for the rotary know, to
--          improve the response of the knob.

-- 20100820 Try to do the following:
--          1. Find the UCF for the third R2R port and another switch connector
--          2. Add an extra R2R outlet in the generator
--          2.5Add another switch board that would allow control of the bandwidth.   
--          3. add Dynamic Bandwidth Allocation program. Allow change through turning of a switch.

-- 20100708 Try to add a third R2R DAC as the modulation drive? 
-- 20100618 Added filter reset button. Changed the performance of the board
--          significantly! Still need to figure out why the lock can be locked
--          partially.
-- 20100611 Merged two versions, and debugged the optimized architecture. 80%
--          resource. Changed to ISE 12.1 that came with the Virtex 4 chip. The 
--          synthesis is running uber fast!!
--          Optimized the code to all state machine. eliminated deep comb.logics
--          and changed the filter archetecture to run 4 clocks for each sample, and 
--          as 50MHz clock. This wasn't possible before! it was running at 25MHz CLK.
--          
-- 20100530 Adding an extra R2R outlet for high definition error signal out.
-- 20100521 deleted the modulation-hold function. 
-- 20100521 Dave want me to delete the modulation-hold function. Not done yet.
-- 20100309 Trying to implement modulation-hold when the ramp is on. succeeded.
-- 20100308 It seems that the Ramp has a floating offset that causes shift of the 
--          output. This need to be fixed. Update: Fixed!
--          Problem solved earlier yesterday. The reason was the Design Strategy was 
--          set to "Timing Constraint" instead of default "balanced".
-- 20100307 Kept getting wierd artifacts in the mixed signal, under both sine and 
--          square dither. May be due to high temeratur of the FPGA? No the program 
--          is somehow corrupted.
-- 20100306 Used the NORTH button to activate detection mode the R2R output, in order
--          to check if there is any problem with the multiplier. It seems that the 
--          program within the FPGA can get corrupted after a while, requireing a
--          re-download.
-- 20100210 Fixed the UI bug, and everything is fine now. There was a ghost bug in 
--          Tau the lock amp time constant code, where tau remains to be a signal. 
--          Surprisingly, this bug was gone after I added tau_temp which is a 
--          variable, and changed all the taus in that part of the code to tau_temp!!
-- 20100208 Finally tested, and things are okay!   
-- 20100208 Tested the previous revision and fixed couple of bugs. the problem was 
--          that the resource went up to 173%. By trial and error, I changed a line 
--          of lcd update code from (lcd_initial+x) to the specific decimal number. 
--          Interestingly, this fixed the problem!
--          I think this is because with more layers of combinatorial logic, the sys-
--          tematic requirement of LUTs will grow much larger.
-- 20100203 Trying to change the increment to ten percent each turn.
-- 20100203 Trying to fix the display to show Ramp is off when off.
-- 20100129 Everything worked! We saw good indication of the current working in 
--          spectral analyzer. It turned out that John's setup has some intrinsic
--          problems: after I removed the resistor box, the current is working!!!
-- 20100118 Changed the current bandwidth from 110 to 011 which increased the
--          bandwidth
-- 20100112 Ramp Fixed
-- 20100112 It turned out that the ramp stopped working. 
-- 20091227 Deactivated the reset button.
-- 20091227 Fixed the program that has been broken from version 20091223, recovered
--          from version 20091128. Updated by first copying the parameter modifier 
--          code directly from version 20091223.
-- 20091121 Implemented linear pre filter gain replacing the logrithmistic gain.
--          Changed the parameter adjustion to be adding or subtraction of 12.5% or 
--          1.5% for fine tuning. minimal additoin and subtraction is 1. 
--          Aligned the multiplication factor of the pre and post filter output. 
--            
-- 20091120 Almost done after a whole night of work. There are still some factor 
--          issue with the pre filtered and post-filtered signal, like before. 
--          will try to solve tonight.
-- 20091119 Damn... messed up my own program again without saving the original...
-- 20091114 Trying to implement a ramp through Channel_Piezo and the Current Polarity
--          Switch.
-- 20091113 Experiment had a ground-breaking success! look-in extremely well!!!
-- 20091112 Coupled DBA to the error Fil/unFil switch, allowing reallocation 
--          On-The-Fly!!!
--          Fixed a bug where the initial DAC_all was not adapted to the new DBA
--          interface.
-- 20091110 Just get to know my GRE Physics score! Dave think I can apply to anywhere
--          now!
-- 20091104 Trying to implement new architecture for dynamic bandwidth allocation
-- 20091103 Fixed the bug of the current switch, so that when it is switched on, no 
--          activation by rotating the knob required. 
--          Also set all the default values to be what John specified to be the 
--          optimum
-- 20091102 Implemented digital square output at J19(0) and J19(1).
--          Fixed the bug of the current ON/OFF switch. Now the switch can switch OFF
-- 20091030 Changed the imput into the board:
--          switched the function of the North and the South button.
--          Implemented a Current ON/OFF switch.
--          Implemented the slide switch format John laid out earlier.
-- 20091017 Increased the gain for piezo, changed the corresponding code for display. 
-- 20090927 Debugged the wrong decimal placement for multiplier gain, by displaying
--          "k" on the second row before the multiplication sign "x" 
--Bugs: 
--

-- Library declarations
--
-- Standard IEEE libraries
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all; 
--
-- The Unisim Library is used to define Xilinx primitives. It is also used during
-- simulation. The source can be viewed at %XILINX%\vhdl\src\unisims\unisim_VCOMP.vhd
--
library unisim;
use unisim.vcomponents.all;
--
--
------------------------------------------------------------------------------------
--
--
entity Controller is
    Port (             
             --LCD Display
                    LCD_DB : inout std_logic_vector(7 downto 0);
                    LCD_RS : out std_logic;
                    LCD_RW : out std_logic;
                     LCD_E : out std_logic;
             --Clock
                   CLK_50M : in std_logic;                       
--Serial Port
                  DAC_CS,SPI_SCK,SPI_MOSI   :   inout   std_logic;
                  DAC_CLR   :   out   std_logic;
                  DAC_OUT   :   in      std_logic;
                  AMP_CS   :   inout   std_logic:='0';
                  AMP_DOUT   :   in      std_logic;
                  AMP_SHDN   :   out   std_logic:='0';
                  AD_CONV   :   inout   std_logic;
                  ADC_OUT   :   in      std_logic;
               --I/O 
                  J18,J19,J20 : inout std_logic_vector(3 downto 0);
                  LED      :    out    std_logic_vector(7 downto 0);
                  SW         :   in      std_logic_vector(3 downto 0);
                  ROT_A,ROT_B,ROT_CENTER : in std_logic;
                  BTN   :   in      std_logic_vector(3 downto 0);
                  R2R,R2R2,R2R3,R2R4   :   out   std_logic_vector(7 downto 0)
                  );
    end Controller;

architecture Behavioral of Controller is
    
  component lcd_drv
    Port ( Clk  : in std_logic;                      -- System Clock``
           Rst  : in std_logic;                      -- asynchronous Reset, active high
           Tick : in std_logic;                      -- Tick at 250 kHz (one clock cycle long)
           Din  : in std_logic_vector (7 downto 0);  -- Input data
           Dav  : in std_logic;                      -- Write Data command (1 clock cycle)
           Busy    : out   std_logic;                -- '1' if device busy
           -- LCD signals
           Dout    : inout std_logic_vector(7 downto 0); -- LCD data is a bidirectional bus...
           Lcd_Sel : out   std_logic;                -- LCD register select`
           Lcd_Rw  : out   std_logic;                -- LCD Read / nWrite
           Lcd_En  : out   std_logic                 -- LCD Enable
         );  
    end component;  
    
  Component Signal_Generator
    Port ( AWG_CLK,Square_wave_handle: in  STD_LOGIC:='1';
           Amp :  in integer range 0 to 4095:=1219;
           Step: in integer range 0 to 4095:=20; 
           Phase: in Integer range 0 to 16383;
           Ch1,Ch2 : out  STD_LOGIC_VECTOR (11 downto 0);
           Digital_Ch1,Digital_Ch2 : out std_logic
           );
   end component; 
   
   component FIR
      port(FIR_CLK  : in std_logic;                      -- System Clock
           conv   : in std_logic;      -- the asynchronous signal for global conversion, since the FIR is sensitive to such time scale
                                       -- 1 clock cycle!!!
           Reset : in std_logic;
           V_in_0  : in std_logic_vector (27 downto 0);  -- Input data
           V_out_0  : inout std_logic_vector (27 downto 0); -- Output data, 28 bits`
           DAC_0,DAC_1,DAC_2,DAC_3   :   out std_logic_vector (27 downto 0);
           FIR_f_0,FIR_f_1,FIR_f_2,FIR_f_3   : in std_logic_vector(13 downto 0);
           FIR_gain_0,FIR_gain_1,FIR_gain_3: in std_logic_vector(15 downto 0)--;
           --FIR_gain_2: in std_logic_vector(15 downto 0)
            );
    end component;
    
   signal FIR_Conv,AD_Conv_Delayed: STD_LOGIC;
   signal V_out, V_piezo, V_current, Lockin_out, piezo_out, current_out, current_out_inverse, 
          Piezo_out_inverse:std_logic_vector(27 downto 0);
   signal Piezo_Handle: Std_logic_vector(1 downto 0);

   signal tau_piezo:std_logic_vector(13 downto 0):="01010010000000";
   --            signal tau_piezo_temp:std_logic_vector(13 downto 0):="01010010000000";
   signal tau_current:std_logic_vector(13 downto 0):="00000000110001";
   --            signal tau_current_temp : std_logic_vector( 13 downto 0):="00000000110001";
   signal Lockin_gain:std_logic_vector(15 downto 0):="0000000001000000";
   signal piezo_gain:std_logic_vector(15 downto 0):="0000000110010100";
   signal current_gain:std_logic_vector(15 downto 0):="0000000001000000";
   signal tau_Highpass:std_logic_vector(13 downto 0):="01100010000000";
   signal Hipass_out :std_logic_vector(27 downto 0);
--
Constant A_Cp : integer := 65;Constant B_Cp : integer := 66;Constant C_Cp : integer := 67;
Constant D_Cp : integer := 68;Constant E_Cp : integer := 69;Constant F_Cp : integer := 70;
Constant G_Cp : integer := 71;Constant H_Cp : integer := 72;Constant I_Cp : integer := 73;
Constant J_Cp : integer := 74;Constant K_Cp : integer := 75;Constant L_Cp : integer := 76;
Constant M_Cp : integer := 77;Constant N_Cp : integer := 78;Constant O_Cp : integer := 79;
Constant P_Cp : integer := 80;Constant Q_Cp : integer := 81;Constant R_Cp : integer := 82;
Constant S_Cp : integer := 83;Constant T_Cp : integer := 84;Constant U_Cp : integer := 85;
Constant V_Cp : integer := 86;Constant W_Cp : integer := 87;Constant X_Cp : integer := 88;
Constant Y_Cp : integer := 89;Constant Z_Cp : integer := 90;
Constant RampAmplitude: std_logic_vector := "0000";
Constant ModulationAmplitude: std_logic_vector := "0001"; 
Constant ModulationFrequency : std_logic_vector := "0010";
Constant CPhase : std_logic_vector := "0011";
Constant LockFrequency : std_logic_vector := "0100";
Constant PiezoFrequency : std_logic_vector := "0101";
Constant HighpassFrequency: std_logic_vector := "0110";
Constant CurrentFrequency: std_logic_vector := "0111";
Constant LockinGain : std_logic_vector := "1000";
Constant PiezoGain : std_logic_vector := "1001";
Constant CurrentGain: std_logic_vector := "1010";

Constant a : integer := 97;Constant b : integer := 98;Constant c : integer := 99;
Constant d : integer := 100;Constant e : integer := 101;Constant f : integer := 102;
Constant g : integer := 103;Constant h : integer := 104;Constant i : integer := 105;
Constant j : integer := 106;Constant k : integer := 107;Constant l : integer := 108;
Constant m : integer := 109;Constant n : integer := 110;Constant o : integer := 111;
Constant p : integer := 112;Constant q : integer := 113;Constant r : integer := 114;
Constant s : integer := 115;Constant t : integer := 116;Constant u : integer := 117;
Constant v : integer := 118;Constant w : integer := 119;Constant x : integer := 120;
Constant y : integer := 121;Constant z : integer := 122;

constant hyphen : integer := 45;

Constant Space : integer := 32;

------------------------------------------------------------------------------------

signal lcd_reset         : std_logic;
signal lcd_ticker        : integer range 0 to 99;
signal lcd_tick          : std_logic;
signal lcd_in            : std_logic_vector (7 downto 0);
signal lcd_w             : std_logic;
signal lcd_flag          : std_logic;
signal lcd_location       : integer range 0 to 31:=0;
signal  lcd_initial  : std_logic_vector(3 downto 0);


type lcd_memory is array(0 to 175) of integer range 0 to 255;
signal lcd1 : lcd_memory :=(   
                              R_Cp,a,m,p,Space,i,s,Space, o,n,32,32,32,32,32,32,   
                              M_Cp,o,d,u,l,a,t,i,o,n,Space,A_Cp,m,p,32,32,       
                              M_Cp,o,d,u,l,a,t,i,o,n,Space,F_Cp,r,e,q,32,    
                              M_Cp,o,d,u,l,a,t,i,o,n,Space,P_Cp,h,a,s,e,          
                              M_Cp,i,x,e,r,Space,L_Cp,P_Cp,F_Cp,32,C_Cp,u,t,o,f,f, 
                              P_Cp,i,e,z,o,32,D_Cp,r,v,32,C_Cp,u,t,o,f,f,  
                              C_Cp,u,r,n,t,32,H_Cp,P_Cp,F_Cp,32,C_Cp,u,t,o,f,f,
                              C_Cp,u,r,n,t,32,L_Cp,P_Cp,F_Cp,32,C_Cp,u,t,o,f,f,
                              P_Cp,o,s,t,176, M_Cp,i,x,e,r,32,G_Cp,a,i,n,32,       
                              P_Cp,i,e,z,o,Space,Space,Space,G_Cp,a,i,n,32,32,32,32, 
                              C_Cp,u,r,r,e,n,t,Space,G_Cp,a,i,n,32,32,32,32    );
                         
type LCD2_type is array(0 to 15) of integer range 0 to 255;
signal lcd2 : LCD2_type;

--type Menu_Table is ()
signal LED_FLASH: STD_LOGIC_VECTOR (7 DOWNTO 0);

--Normal Signals borrowed from previous project

signal BTN0      : std_logic_vector(3 downto 0);
signal Confirm   : integer range 0 to 1;

Signal Amp      :   integer range 0 to 4095:=1219;  --Modulation Amplitude at 1.00 V
Signal Phase   :   integer range 0 to 16383:=13025; --Phase shift at 1.59 Pi
signal Step      : integer range 0 to 4095:=20; --Modulation Frequency at 60kHz is 19.6875 with high clock--Modulation Frequency at 60kHz
signal tau      : std_logic_vector(13 downto 0):="00000010100000";--floating point!!
signal Gain      :   std_logic_vector(11 downto 0):="000000000001";
signal Gain_int: integer range 0 to 4095;

signal Primer       :    std_logic_vector(10 downto 0):="10000010010"; --  10000010010  Originally the initial value was 1042, then I increased this to a bigger value to make it possible to have a different DAC_Amp initial value at booting. 1042
signal Counter    :    std_logic_vector(63 downto 0):= "0000000000000000000000000000000000000000000000000000000000000000"; 
signal DAC_all      :   std_logic_vector(127 downto 0):= "00000000001111111111111111110001000000000011101011111111111100010000000000110101111111111111000100000000001100001111111111110001"; --the last digit has to be 1 such that this is only 0 when 32 bit has been done

signal DAC_temp   :   std_logic_vector(31 downto 0):= "00010001000100010001000100010001";
signal DAC_A,DAC_A_Signed   :   std_logic_vector(11 downto 0):= "111111111111";

--signal DAC_A_Counter   :   integer range 0 to 16383;
--signal DAC_A_Counter0   :   integer range 0 to 16383;
signal DAC_B   :   std_logic_vector(11 downto 0):= "011111111111";
signal DAC_B_Counter   :   integer range 0 to 16383;
signal Mod_A,Mod_A_Signed   :   std_logic_vector(11 downto 0):= "011111111111";


signal DAC_C   :   std_logic_vector(11 downto 0):= "111111111111";
signal DAC_D   :   std_logic_vector(11 downto 0):= "011111111111";
--signal Sine1   :   integer range 0 to 16777216;
--signal Sine2   :   integer range 0 to 16777216;
--signal Sine3   :   integer range 0 to 16777216;
--signal Sine4   :   integer range 0 to 16777216;
 

signal ADC_in   :   std_logic_vector(34 downto 0);
signal ADC_inA   :   std_logic_vector(13 downto 0);
signal ADC_inB   :   std_logic_vector(13 downto 0);
signal ADC_inA_Original   :   std_logic_vector(13 downto 0);
signal ADC_inB_Original   :   std_logic_vector(13 downto 0);
signal ADC_Counter   :   std_logic_vector(6 downto 0):= "0000000";

signal ROT_AR   :   std_logic;
signal ROT_BR   :   std_logic;
signal ROT_A0   :   integer range 0 to 1;
signal ROT_B0   :   integer range 0 to 1;
signal ROT_r   :   integer range 0 to 7;--std_logic_vector(7 downto 0):="10000000";
signal ROT_Abuff: std_logic_vector(32 downto 0);
signal ROT_Bbuff: std_logic_vector(32 downto 0);
signal ROT_Av   : integer range 0 to 1;
signal ROT_Bv   : integer range 0 to 1;





signal Sig_Conv:   std_logic_vector(27 downto 0);--28 bits to allow 14bit multiplication
--signal Gain   :   std_logic_vector(11 downto 0):="000100000000";
signal Sig1:   std_logic_vector(41 downto 0);
signal Sig2:   std_logic_vector(41 downto 0);
signal Sig3:   std_logic_vector(41 downto 0);
signal Sig4:   std_logic_vector(41 downto 0);

   signal ramp_amp: std_logic_vector(10 downto 0):="11111111111";
   signal MultiplierHandle : std_logic_vector(1 downto 0);
   Signal ramp_f_pointer:integer range 0 to 15:=6;
   signal ramp_adpt:std_logic_vector(22 downto 0);
--signal setamp   :   std_logic_vector(7 downto 0)   := "00010001"; 
--signal Counter00   :   std_logic_vector(7 downto 0)   := "00000000";
--signal ampresettime   :   std_logic_vector(1 downto 0)   := "00";

begin
device_lcd: lcd_drv
    port map(   
           Clk => CLK_50M,                 -- System Clock
           Rst  => lcd_reset,              -- asynchronous Reset, active high
           Tick => lcd_tick,               -- Tick at 250 kHz (one clock cycle long)
           Din  => lcd_in,                 -- Input data
           Dav  => lcd_w,                  -- Write Data command (1 clock cycle)
           Busy => lcd_flag,               -- '1' if device busy
           -- LCD signals
           Dout    => LCD_DB, -- LCD data is a bidirectional bus...
           Lcd_Sel => LCD_RS,              -- LCD register select
           Lcd_Rw  => LCD_RW,              -- LCD Read / nWrite
           Lcd_En  => LCD_E                -- LCD Enable
           );
           
device_fir: FIR
    port map(   
           FIR_CLK  => Counter(1),  -- System Clock
           conv   => FIR_CONV,         -- the asynchronous signal for global conversion, since the FIR is sensitive to such time scale
                                    -- 1 clock cycle!!!
           reset => BTN(0),
      --Channel 0
           V_in_0  => Sig_Conv,  -- Input data
           V_out_0 => V_out,     -- Prefiltered data, 28 bits
           
          
           FIR_f_0   =>tau,       -- LCD Enable
           FIR_gain_0=>Lockin_gain,
           DAC_0=>lockin_out,--piezo_out,
      --Channel 1
--           V_in_1  => lockin_out,  --V_out,  -- Input data
--           V_out_1 => V_piezo,     -- Output data, 28 bits
           FIR_f_1   =>tau_piezo,       -- LCD Enable
           FIR_gain_1=>piezo_gain,
           DAC_1(27)=>piezo_out(27),
           DAC_1(20 downto 0)=>piezo_out(26 downto 6),
           DAC_1(26 downto 21)=>piezo_out(5 downto 0),
           
      --Low-pass filter set
--           V_in_2  => lockin_out,  --V_out,  -- Input data
--           V_out_2 => V_capacitor,     -- Output data, 28 bits
           FIR_f_2   =>tau_Highpass,       -- LCD Enable
           --FIR_gain_2=>current_gain,
           DAC_2=>Hipass_out,
           
      --Channel 2
--           V_in_3  => Hipass_out,  --V_out,  -- Input data
--           V_out_3 => V_current,     -- Output data, 28 bits
           FIR_f_3   =>tau_current,       -- LCD Enable
           FIR_gain_3=>current_gain,
           DAC_3=>current_out
           
           );
   DAC_CLR <= '1';
   AMP_SHDN <= '0';
   J19(2)   <= '0';
   J19(3)   <= '0';

Multiplier:process(CLK_50M)
   begin
      if rising_edge(CLK_50M) then
      Sig1(27 downto 0)<=(ADC_inA(13 downto 0))*(("100"&Mod_A(10 downto 0))-"01111111111111");
      Sig2(27 downto 0)<=(ADC_inA(13 downto 0))*("01111111111111"-("011" & Mod_A(10 downto 0)));
      MultiplierHandle<=ADC_inA(13)&Mod_A(11);
--Multiplier Unit   
        Case MultiplierHandle(0) is
         when '1' => Sig_Conv(27 downto 0) <= "0111111111111111111111111111"+Sig1(27 downto 0); --Originally 37 to 10
         when '0' => Sig_Conv(27 downto 0) <= "0111111111111111111111111111"-Sig2(27 downto 0);
         when Others => null;
        END CASE;
      end  if;
   end process Multiplier;
--*****************************************************************************

AWG:Signal_Generator
    Port map( 
           AWG_CLK=> CLK_50M,
           Square_wave_handle=>sw(1),
           Amp=>Amp,
           Step=>Step,
           Phase=>Phase,
           Ch1=>DAC_A_Signed,            Ch2=>Mod_A_Signed,
           Digital_Ch1=>J19(0),   Digital_Ch2=>J19(1)
           );
--*****************************************************************************
DAC_A<=DAC_A_Signed+"100000000000";
Mod_A<=Mod_A_Signed+"100000000000";

Analog_In_Out: process (clk_50m)      
   begin
      DAC_D(11 downto 0) <= current_out_inverse(27 downto 16);
      Case sw(3) is
       when '1' =>
            R2R(7 downto 0) <= V_out(27 downto 20);
            R2R2(7 downto 0) <= Hipass_out(27) & Hipass_out(23 downto 17);
            R2R3<=Dac_a(11 downto 4);
            R2R4<=Sig_Conv(27 downto 20);
       When '0' => 
            R2R(7 downto 0) <= lockin_out(27) & lockin_out(24 downto 18);
            R2R2(7 downto 0) <= lockin_out(27) & lockin_out(21 downto 15);
            --    Function of R2R2 is to output Magnified error signal for Laser Linewidth characterization.
            R2R3<=Mod_A(11 downto 4);
            R2R4<=ADC_inA(13 downto 6);
       when others =>
      end case;
      current_out_inverse <= "0000000000000000000000000000"-current_out;
      Piezo_out_inverse <= "0000000000000000000000000000"-Piezo_out;         
      Piezo_Handle<=J18(0)& sw(1);
      case Piezo_Handle is 
       when "00" => DAC_C(11 downto 0) <= Piezo_out_inverse(27 downto 16);      
       when "10" => DAC_C(11 downto 0) <= Piezo_out(27 downto 16);   
       when "01" => DAC_C(11 downto 0) <= ramp_adpt(22 downto 11);
       when "11" => DAC_C(11 downto 0) <= ramp_adpt(22 downto 11);
       when others =>
      end case;
end Process Analog_In_Out;

-- The General Bus and SPI bus clock divider
Process(CLK_50M)
   begin
      if DAC_temp = "00000000000000000000000000000000" then
         DAC_CS   <= '1';
      else 
         DAC_CS   <= '0';
         
      end if;
      Counter(0) <= CLK_50M;
      if CLK_50M'event and CLK_50M = '0' then
               AD_Conv_Delayed<=AD_Conv;
               FIR_Conv<=AD_Conv or AD_Conv_Delayed;
         Counter(63 downto 1) <= Counter(63 downto 1) +1;
--Primer: Defined to give a different SPI bus clock at the begining, so that it works          
         if Primer(10 downto 1) /=  "0100000111" then--0d263
            Primer(10 downto 0) <= Primer(10 downto 0) -1;
            SPI_SCK    <= Counter(4); --the Pre Amp requires at least 50 ns per clock cycle. therefore, here we set it up as 80 ns
            if Primer(6 downto 3) = "0010" then   
               AMP_CS   <= '1';
            else
               AMP_CS   <= '0';
            end if;
         end if;   
      end if;
      if Primer(10 downto 1)= "0100000111" then
         SPI_SCK    <= Counter(0);
         AMP_CS   <= '1';
      end if;
      
   end process;
   
-- The DAC Input
--AD_CONV <= DAC_CS;

            SPI_MOSI   <= DAC_temp(31);
            ADC_in(0) <= ADC_OUT;
process(SPI_SCK)

   variable DAC_Bandwidth_counter_a :std_logic_vector(5 downto 0):="000000";
   variable DAC_Bandwidth_counter_b :std_logic_vector(5 downto 0):="000010";
   variable DAC_Bandwidth_counter_c :std_logic_vector(5 downto 0):="000101";
   variable DAC_Bandwidth_counter_d :std_logic_vector(5 downto 0):="000001";
   
   begin
      if rising_edge(SPI_SCK) then
         if DAC_CS = '0' then
            DAC_temp(31 downto 1)<= DAC_temp(30 downto 0);
            DAC_temp(0) <= '0';
            
         else 


            if DAC_all(115 downto 114) = "00" then
               DAC_all(127 downto 32) <=DAC_all(95 downto 0);
               DAC_all(31 downto 16) <= "0000000000110000";
               DAC_all(15 downto 4) <= DAC_A(11 downto 0);
               DAC_all(3 downto 0) <= "0001";
            end if;
            Case DAC_all(115 downto 114) is
             when "01" =>            -- Out one channle B in every 10 outputs.                                                         
               --J19(3) <= '1';                                -- Or when the error Fil/unFil witch is ON!
--               if sw(3)='1' or  DAC_Bandwidth_counter_b= "000110" then      -- max out at 10.
--                  --J19(2)   <= '1';
--                  DAC_Bandwidth_counter_b:="000000";
--                  DAC_all(17 downto 16) <= "01";
--                  DAC_all(15 downto 4) <= DAC_B(11 downto 0);
--               ELSE
                  --J19(2)   <= '0';
                  DAC_Bandwidth_counter_b:=DAC_Bandwidth_counter_b+1;
                  DAC_all(17 downto 16) <= "00";
                  DAC_all(15 downto 4) <= DAC_A(11 downto 0);-- Mostly outputs A instead.
--               end if;
               DAC_all(127 downto 32) <=DAC_all(95 downto 0);
               DAC_all(31 downto 18) <= "00000000001101";
               DAC_all(3 downto 0) <= "0001";
            --else J19(3) <= '0';
             When "10" =>
               if DAC_Bandwidth_counter_c= "001010" then 
                  DAC_Bandwidth_counter_c:="000000";
                  DAC_all(17 downto 16) <= "10";
                  DAC_all(15 downto 4) <= DAC_C(11 downto 0);
               ELSE
                  DAC_Bandwidth_counter_c:=DAC_Bandwidth_counter_c+1;
                  DAC_all(17 downto 16) <= "00";
                  DAC_all(15 downto 4) <= DAC_A(11 downto 0);-- Mostly outputs A instead.
               end if;
               DAC_all(127 downto 32) <=DAC_all(95 downto 0);
               DAC_all(31 downto 18) <= "00000000001110";
               DAC_all(3 downto 0) <= "0001";
             When "11" =>
               --if DAC_Bandwidth_counter_d= "000010" then 
                  DAC_Bandwidth_counter_d:="000000";
                  DAC_all(17 downto 16) <= "11";
                  DAC_all(15 downto 4) <= DAC_D(11 downto 0);
--               ELSE
--                  DAC_Bandwidth_counter_d:=DAC_Bandwidth_counter_d+1;
--                  DAC_all(17 downto 16) <= "00";
--                  DAC_all(15 downto 4) <= DAC_A(11 downto 0);-- Mostly outputs A instead.
--               end if;
               DAC_all(127 downto 32) <=DAC_all(95 downto 0);
               DAC_all(31 downto 18) <= "00000000001111";
               DAC_all(3 downto 0) <= "0001";
            When Others => null;
            End Case;
            DAC_temp(31 downto 0) <= DAC_all(31 downto 20) & "00" & DAC_all(17 downto 0);
--            Only uses the last two digist of 19-16 to export.
--            The first two digits are used to tell this dynamic 
--            band width allocation program what is was originally.
         end if;

      end if;
--   ADC reading code          
      --First we need to invert the incoming signal, because the hardware design of this board determines that the incoming signal is inverted 
      ADC_inA(13 downto 0)<=ADC_inA_Original(13 downto 0);
      ADC_inB(13 downto 0)<=ADC_inB_Original(13 downto 0);      
      if rising_edge(SPI_SCK) then   
         if AD_CONV = '0' then
            ADC_in(34 downto 1) <= ADC_in(33 downto 0);
            --ADC_in(31) <= ADC_OUT;
            ADC_Counter(6 downto 0) <= ADC_Counter(6 downto 0)-1;
            if ADC_Counter(6 downto 0) = "0000000" then
               AD_CONV <= '1';
               ADC_Counter(6 downto 0) <= "0100010";
               ADC_inA_Original(13 downto 0) <= ADC_in(32 downto 19)+"10000000000000"; -- this is signed. a way to make it unsigned from 0 to 11111... is by adding 10000000000000 
               ADC_inB_Original(13 downto 0) <= ADC_in(16 downto 3)+"10000000000000";
            end if;
         else
            AD_CONV <= '0';
         end if;
      end if;
   end process;
      
      -- 011111111 is -1 00000000+0111111=01111111      
      --                 01111111+0111111=11111110
      --                 10000000+0111111=11111111
      --                 10000000+1000000=00000000  so it should have been 100000 instead of 0111111
      
Tick_generator: process(Counter(1))
    variable  lcd_ABS_location : integer range 0 to 255:=0;
    variable lcd_ABS_location_ln2 : integer range 0 to 255:=0; 
  begin
       
--    J20(3)<=lcd_tick;
--    J20(2)<=lcd_flag;
--    J20(1)<=lcd_w;
--    J20(1)<=ROT_A;
     LED<=LED_Flash; --conv_std_logic_vector(lcd_initial, 8);

    
    if Counter(1)'event and Counter(1)='1' then
--General Clock Signal to the LCD Modulo
--      Counter<=Counter+1;
      lcd_ticker<=lcd_ticker+1;
      if lcd_ticker =0 then
         lcd_tick <= '1'; 
      else lcd_tick <='0';
      end if;
      
--Writing Modulo to the LCD, to maximum speed   
      if lcd_flag='0' and lcd_w='0' then
         lcd_location<=lcd_location+1;lcd_w<='1';
      else lcd_w<='0';
      if lcd_reset='1' then lcd_location <= 0;  end if;
      end if;
--Some Random Stuff, aHAHAHAHAHA!!!!! AHAHAHAHAHA
      lcd_ABS_location := lcd_location + conv_integer(lcd_initial & "0000");
      lcd_ABS_location_ln2 := lcd_location -16;--+ conv_integer(lcd_initial & "0000")-16; -- "-16"because want to subtract 16 for the second line. Lcd_location starts at 16 instead of 0.
          if lcd_location<16 then 
            lcd_in<=conv_std_logic_vector(lcd1(lcd_ABS_location),8);
         else 
            lcd_in<=conv_std_logic_vector(lcd2(lcd_ABS_location_ln2),8);
         end if;
    end if;

end process Tick_generator;

    
Ramp: process(CLK_50M)
   variable ramp:std_logic_vector(13 downto 0);
--   variable ramp_adpt:std_logic_vector(22 downto 0);
   variable ramp_polarity:std_logic;
   variable ramp_freq:std_logic_vector(15 downto 0);
--   Variable ramp_f_pointer:integer range 0 to 15;
   
  begin
   if rising_edge(CLK_50M) then
--      Ramp (high clock speed)
--      if sw(1)='1' then 
--         DAC_C(11 downto 0) <= ramp_adpt(22 downto 11);
         ramp_adpt<=ramp(13 downto 2)*ramp_amp+"10000000000000000000000"-(ramp_amp & "00000000000"); --got rid of one bit
         Ramp_freq:=Ramp_freq+1;
         if ramp_freq(ramp_f_pointer)='1' then Ramp_freq:="0000000000000000";
             -- The last bit of Counter is always 1 in this process.
            if ramp_polarity='0' then ramp:=ramp+1;   else ramp:=ramp-1; end if;
            
         end if;
         if ramp(13 downto 2)="111111111111" then ramp_polarity:='1'; end if;
         if ramp(13 downto 2)="000000000000" then ramp_polarity:='0'; end if;
--      else 
--         DAC_C(11 downto 0) <= piezo_out(27 downto 16);
--      end if;
   end if;
  end process Ramp;
   
   
Human_Interface: process(Counter(12))
   variable lcd_initial_temp:std_logic_vector(3 downto 0);
   variable tau_temp : std_logic_vector( 13 downto 0):="00000010100000";
   variable tau_current_temp : std_logic_vector( 13 downto 0):="00000000110001";
   variable tau_piezo_temp:std_logic_vector(13 downto 0):="01010010000000";
  begin
    ROT_Abuff(0) <= ROT_A;
    ROT_Bbuff(0) <= ROT_B;    
    if rising_edge(Counter(12)) then--CLK_50M'event and CLK_50M='1' then
    
         ROT_Abuff(32 downto 1)<=ROT_Abuff(31 downto 0);
         ROT_Bbuff(32 downto 1)<=ROT_Bbuff(31 downto 0);
         ROT_Av<=(conv_integer(ROT_Abuff(1))+conv_integer(ROT_Abuff(2))+conv_integer(ROT_Abuff(3))+conv_integer(ROT_Abuff(4))+conv_integer(ROT_Abuff(5))+conv_integer(ROT_Abuff(6))+conv_integer(ROT_Abuff(7))+conv_integer(ROT_Abuff(8))+conv_integer(ROT_Abuff(9))+conv_integer(ROT_Abuff(10))+conv_integer(ROT_Abuff(11))+conv_integer(ROT_Abuff(12))+conv_integer(ROT_Abuff(13))+conv_integer(ROT_Abuff(14))+conv_integer(ROT_Abuff(15))
                  +conv_integer(ROT_Abuff(16))--+conv_integer(ROT_Abuff(17))+conv_integer(ROT_Abuff(18))+conv_integer(ROT_Abuff(19))+conv_integer(ROT_Abuff(20))
                  --+conv_integer(ROT_Abuff(21))+conv_integer(ROT_Abuff(22))+conv_integer(ROT_Abuff(23))+conv_integer(ROT_Abuff(24))+conv_integer(ROT_Abuff(25))+conv_integer(ROT_Abuff(26))+conv_integer(ROT_Abuff(27))+conv_integer(ROT_Abuff(28))+conv_integer(ROT_Abuff(29))+conv_integer(ROT_Abuff(30))
                  --+conv_integer(ROT_Abuff(31))+conv_integer(ROT_Abuff(32))
                  )/16;
         ROT_Bv<=(conv_integer(ROT_Bbuff(1))+conv_integer(ROT_Bbuff(2))+conv_integer(ROT_Bbuff(3))+conv_integer(ROT_Bbuff(4))+conv_integer(ROT_Bbuff(5))+conv_integer(ROT_Bbuff(6))+conv_integer(ROT_Bbuff(7))+conv_integer(ROT_Bbuff(8))+conv_integer(ROT_Bbuff(9))+conv_integer(ROT_Bbuff(10))
                  +conv_integer(ROT_Bbuff(11))+conv_integer(ROT_Bbuff(12))+conv_integer(ROT_Bbuff(13))+conv_integer(ROT_Bbuff(14))+conv_integer(ROT_Bbuff(15))+conv_integer(ROT_Bbuff(16))--+conv_integer(ROT_Bbuff(17))+conv_integer(ROT_Bbuff(18))+conv_integer(ROT_Bbuff(19))+conv_integer(ROT_Bbuff(20))
                  --+conv_integer(ROT_Bbuff(21))+conv_integer(ROT_Bbuff(22))+conv_integer(ROT_Bbuff(23))+conv_integer(ROT_Bbuff(24))+conv_integer(ROT_Bbuff(25))+conv_integer(ROT_Bbuff(26))+conv_integer(ROT_Bbuff(27))+conv_integer(ROT_Bbuff(28))+conv_integer(ROT_Bbuff(29))+conv_integer(ROT_Bbuff(30))
                  --+conv_integer(ROT_Bbuff(31))+conv_integer(ROT_Bbuff(32))
                  )/16;
   --      Ramp (low clock speed)
         if sw(1)='1' then 
            tau_Piezo<="11000000000001";
            lcd_initial<="0000";
            LED_flash(5 downto 0)<=ramp_amp(10 downto 5); 
         else 
            tau_Piezo<=tau_Piezo_temp;
            lcd_initial<=lcd_initial_temp;
         end if;

   --      Current On/Off
         if sw(2 downto 1)="00" then 
            tau_current<=tau_current_temp;
         else tau_current<="10000000000001";
         end if;         
   --    PID servo
         tau<=tau_temp;
         
         If ROT_Av=0 and ROT_A0=1 and ROT_Bv=0 then 
            ROT_AR <='1';ROT_A0<=ROT_Av;
         Else 
            If ROT_Av=1 and ROT_A0=0 and ROT_Bv=1 and ROT_AR='1' then 
               ROT_r<=ROT_r +1;
--               if Confirm=0 then
--                  LED_Flash(7)<='1';
--                  LED_Flash(6 downto 0)<=conv_std_logic_vector(lcd_initial,7);
--                  if ROT_CENTER='0' then
--                     lcd_initial_temp:=lcd_initial_temp+1;
--                  else 
--                     lcd_initial_temp:=lcd_initial_temp+4;
--                  end if;
--               else 
                  if ROT_CENTER='0' then--Confirm = '1'
                    Case LCD_initial is   
                     When ModulationAmplitude =>if BTN(2)='0' and Amp<64 then Amp<=0;else Amp<=Amp-64;end if;
                      --Mdulation Amplitude
                     
                     When ModulationFrequency =>if BTN(2)='0' and Step<32 then Step<=0;else Step<=Step-32;end if;
                      --Modulation Frequency
                     
                     When CPhase =>Phase<=Phase-128; 
                     
                     When LockFrequency => if BTN(2)='0' and (tau_temp=(4096) ) then tau_temp:="01000000000000";else tau_temp:=tau_temp-tau_temp(11 downto 3)-1;end if;
                      --Filter Time Constant
                     
                     When LockinGain =>if BTN(2)='0' and Lockin_gain=0 then else Lockin_gain<=Lockin_gain-Lockin_gain(15 downto 3)-1;end if;
                      -- Multiplier Gain
                     
                     When PiezoFrequency =>if BTN(2)='0' and (tau_piezo_temp=(4096)) then tau_piezo_temp:="01000000000000";else tau_piezo_temp:=tau_piezo_temp-tau_piezo_temp(11 downto 3)-1;end if;
                      --Filter Time Constant
                     
                     When PiezoGain =>if BTN(2)='0' and piezo_gain=0 then else piezo_gain<=piezo_gain-piezo_gain(15 downto 3)-1;end if;
                      -- Multiplier Gain
                     
                     When HighpassFrequency =>if BTN(2)='0' and tau_Highpass=(4096) then tau_Highpass<="01000000000000";else tau_Highpass<=tau_Highpass-tau_Highpass(11 downto 3)-1;end if;
                      --Filter Time Constant
                     
                     When CurrentFrequency =>if BTN(2)='0' and tau_current_temp=(4096) then tau_current_temp:="01000000000000";else tau_current_temp:=tau_current_temp-tau_current_temp(11 downto 3)-1;end if;
                     --Filter Time Constant
                     
                     When CurrentGain =>if BTN(2)='0' and current_gain=0 then else current_gain<=current_gain-current_gain(15 downto 3)-1;end if;
                     
                     When RampAmplitude =>if BTN(2)='0' and ramp_amp=0 then else ramp_amp<=ramp_amp-ramp_amp(10 downto 3)-1;end if;
                     
                     when others => null;
                    end case;
                     
                  else --Confirm = 2
                    Case LCD_initial is   
                        
                     When ModulationAmplitude =>if BTN(2)='0' and Amp=0 then else Amp<=Amp-1;end if;
                     
                     When ModulationFrequency =>if BTN(2)='0' and Step=0 then else Step<=Step-1;end if;
                     
                     When CPhase =>Phase<=Phase-1; 
                     
                     When LockFrequency =>if BTN(2)='0' and tau_temp=4096 then else tau_temp:=tau_temp-tau_temp(11 downto 6)-1;end if;
            
                     
                     When LockinGain =>if BTN(2)='0' and Lockin_gain=0 then else Lockin_gain<=Lockin_gain-Lockin_gain(15 downto 6)-1;end if;
                  
                     
                     When PiezoFrequency =>if BTN(2)='0' and tau_piezo_temp=4096 then else tau_piezo_temp:=tau_piezo_temp-tau_piezo_temp(11 downto 6)-1;end if;
                     
                     When PiezoGain =>if BTN(2)='0' and piezo_gain=0 then else piezo_gain<=piezo_gain-piezo_gain(15 downto 6)-1;end if;
                  
                     When HighpassFrequency =>if BTN(2)='0' and tau_Highpass=4096 then else tau_Highpass<=tau_Highpass-tau_Highpass(11 downto 6)-1;end if;
                     
                     When CurrentFrequency =>if BTN(2)='0' and tau_current_temp=4096 then else tau_current_temp:=tau_current_temp-tau_current_temp(11 downto 6)-1;end if;
                     
                     When CurrentGain =>if BTN(2)='0' and current_gain=0 then else current_gain<=current_gain-current_gain(15 downto 6)-1;end if;
                     
                     When RampAmplitude =>if BTN(2)='0' and ramp_f_pointer=0 then else ramp_f_pointer<=ramp_f_pointer-1;end if;
                     
                     when others => null;
                    end case;
                     
                     
                     
                  end if;
--               end if;                
               ROT_AR<='0';
               ROT_A0<=ROT_Av;
            else 
               ROT_A0<=ROT_Av;
            End if;            
         End if;
         
         --Confirmation State Machine
         --if Counter(12 downto 11)="01" then --rising edge
--            if BTN(0)='1' and BTN0(2)='0' then 
--               Confirm<=Confirm+1;
--            end if;   
            Confirm<=1;
            BTN0(2)<=BTN(0); --Makes the BTN0 a signal that is delayed 20 ms from the BTN itself, NOT functioning as a buffer.
            --west Button
            if BTN(3)='1' and BTN0(3)='0' then 
               if lcd_initial_temp >0 then lcd_initial_temp:=lcd_initial_temp-1; 
               else lcd_initial_temp:=lcd_initial_temp+10; 
               end if;
            end if;   
            BTN0(3)<=BTN(3); --Makes the BTN0 a signal that is delayed 20 ms from the BTN itself, NOT functioning as a buffer.
            --East Button
            if BTN(1)='1' and BTN0(1)='0' then 
               if lcd_initial_temp <10 then lcd_initial_temp:=lcd_initial_temp+1; 
               else lcd_initial_temp:=lcd_initial_temp-10;
               end if;
            end if;   
            BTN0(1)<=BTN(1); --Makes the BTN0 a signal that is delayed 20 ms from the BTN itself, NOT functioning as a buffer.
         --end if;
         
         LED_Flash(7 downto 7)<=conv_std_logic_vector(Confirm,1);
         
         
         
         If ROT_Bv=0 and ROT_B0=1 and ROT_Av=0 then 
            ROT_BR<='1';ROT_B0<=ROT_Bv;
         Else 
            If ROT_Bv=1 and ROT_B0=0 and ROT_Av=1 and ROT_BR='1' then 
               ROT_r<=ROT_r -1;   
--               if Confirm=0 then
----                  LED_Flash(7)<='1';
--                  if ROT_CENTER='0' then
--                     lcd_initial_temp:=lcd_initial_temp-1;
--                  else 
--                     lcd_initial_temp:=lcd_initial_temp-4;
--                  end if;
--               else 
                  if ROT_CENTER='0' then--Confirm = '1'
                    Case LCD_initial is   
                        
                     When ModulationAmplitude =>if BTN(2)='0' and Amp>4095-64 then Amp<=4095;else Amp<=Amp+64;end if;
                     
                     When ModulationFrequency =>if BTN(2)='0' and Step>4095-32 then Step<=4095;else Step<=Step+32;end if;
                     
                     When CPhase =>Phase<=Phase+128; 
                     
                     When LockFrequency =>if BTN(2)='0' and (tau_temp>(4095-511) and tau_temp<4096) then tau_temp:="00111111111111";else tau_temp:=tau_temp+tau_temp(11 downto 3)+1;end if;
                     
                     When  LockinGain =>if BTN(2)='0' and Lockin_gain>65535-8192 then Lockin_gain<="1111111111111111"; else Lockin_gain<=Lockin_gain+Lockin_gain(15 downto 3)+1;end if;
                     
                     When  PiezoFrequency =>if BTN(2)='0' and (tau_piezo_temp>(4095-511) and tau_piezo_temp<4096) then tau_piezo_temp:="00111111111111";else tau_piezo_temp:=tau_piezo_temp+tau_piezo_temp(11 downto 3)+1;end if;
                     
                     When  PiezoGain =>if BTN(2)='0' and piezo_gain>65535-8192 then piezo_gain<="1111111111111111"; else piezo_gain<=piezo_gain+piezo_gain(15 downto 3)+1;end if;
                  
                     When  HighpassFrequency  =>if BTN(2)='0' and (tau_Highpass>(4095-511) and tau_Highpass<4096) then tau_Highpass<="00111111111111";else tau_Highpass<=tau_Highpass+tau_Highpass(11 downto 3)+1;end if;
                     
                     When  CurrentFrequency =>if BTN(2)='0' and (tau_current_temp>(4095-511) and tau_current_temp<4096) then tau_current_temp:="00111111111111";else tau_current_temp:=tau_current_temp+tau_current_temp(11 downto 3)+1;end if;
                     
                     When  CurrentGain =>if BTN(2)='0' and current_gain>65535-8192 then current_gain<="1111111111111111"; else current_gain<=current_gain+current_gain(15 downto 3)+1;end if;
                     
                     When RampAmplitude =>if BTN(2)='0' and ramp_amp>(2047-255) then ramp_amp<="11111111111"; else ramp_amp<=ramp_amp+ramp_amp(10 downto 3)+1;end if;
                     
                     when others => null;
                    end case;
                     
                     
                  else --Confirm = 2
                    Case LCD_initial is   
                        
                     When ModulationAmplitude =>if BTN(2)='0' and Amp=4095 then else Amp<=Amp+1;end if;
                     
                     When ModulationFrequency =>if BTN(2)='0' and Step=4095 then else Step<=Step+1;end if;
                     
                     When CPhase =>Phase<=Phase+1; 
                     
                     When LockFrequency =>if BTN(2)='0' and tau_temp >(4095-63) and tau_temp< 4096 then tau_temp:="00111111111111"; else tau_temp:=tau_temp+tau_temp(11 downto 6)+1;end if;
                     
                     When LockinGain =>if BTN(2)='0' and Lockin_gain>(65535-1024) then Lockin_gain<="1111111111111111";else Lockin_gain<=Lockin_gain+Lockin_gain(15 downto 6)+1;end if;
                     
                     When PiezoFrequency =>if BTN(2)='0' and (tau_piezo_temp>(4095-63) and tau_piezo_temp<4096) then tau_piezo_temp:="00111111111111"; else tau_piezo_temp:=tau_piezo_temp+tau_piezo_temp(11 downto 6)+1;end if;
                     
                     When PiezoGain =>if BTN(2)='0' and piezo_gain>(65535-1024) then piezo_gain<="1111111111111111" ;else piezo_gain<=piezo_gain+piezo_gain(15 downto 6)+1;end if;
                     
                     When HighpassFrequency =>if BTN(2)='0' and (tau_Highpass>(4095-63) and tau_Highpass<4096) then tau_Highpass<="00111111111111"; else tau_Highpass<=tau_Highpass+tau_Highpass(11 downto 6)+1;end if;
                     
                     When CurrentFrequency =>if BTN(2)='0' and (tau_current_temp>(4095-63) and tau_current_temp<4096) then tau_current_temp:="00111111111111"; else tau_current_temp:=tau_current_temp+tau_current_temp(11 downto 6)+1;end if;
                     
                     When CurrentGain =>if BTN(2)='0' and current_gain>(65535-1024) then current_gain<="1111111111111111" ;else current_gain<=current_gain+current_gain(15 downto 6)+1;end if;
                     
                     When RampAmplitude =>if BTN(2)='0' and ramp_f_pointer=15 then else ramp_f_pointer<=ramp_f_pointer+1;end if;
                     
                     when others => null;
                    end case;
                     
                  end if;
--               end if;         
               ROT_BR<='0';
               ROT_B0<=ROT_Bv; 
            else 
               ROT_B0<=ROT_Bv;
            End if;
         End if;
    end if; 
  end process Human_Interface;
  

  
Display_conversion : process(CLK_50M)
   --variable step_vector : std_logic_vectr (11 downto 0);
   type expo_array is array (0 to 15) of std_logic_vector(15 downto 0);
   variable expo_table : expo_array:=(   "0000000000000001","0000000000000010","0000000000000100",
                                       "0000000000001000","0000000000010000","0000000000100000","0000000001000000",
                                       "0000000010000000","0000000100000000","0000001000000000","0000010000000000",
                                       "0000100000000000","0001000000000000","0010000000000000","0100000000000000","1000000000000000");
--   variable expo   : std_logic_vector(14 downto 0);
   type Dec_table is array (0 to 10) of integer range 0 to 10;
   variable Dec :Dec_table;
   variable Dec_out : Dec_table;
   variable Flag : integer range 0 to 1:=0;
   variable Bin0   :   integer range 0 to 1000000000;--max 4294967295
   variable Bin   : integer range 0 to 1000000000;
   variable numerator : std_logic_vector(45 downto 0);
   variable numerator_in : std_logic_vector(29 downto 0);
   variable num_expo : std_logic_vector(42 downto 0);
   variable numerator_out : std_logic_vector(45 downto 0);
   
   variable vector : std_logic_vector(11 downto 0);
   variable FIR_f_mux : std_logic_vector(1 downto 0);
   variable Unit : integer range 0 to 255;
   
   variable gain_mux : std_logic_vector(15 downto 0);
   
   variable Volt0: integer range 0 to 1500000000;
   
   variable lcd_initial_32: std_logic_vector(1 downto 0);
   variable lcd_initial_10: std_logic_vector(1 downto 0);
   variable lcd_initial_1: std_logic;
   variable lcd_initial_0: std_logic;
   
   begin
   
   
   
   
      if CLK_50M'event and CLK_50M='1' then
         --lcd(143) is the location for our first number
         
         --Filter Time Constant
         --tau_int<=conv_integer(tau);
         --20090731 added Logic for an LCD reset button as the following
         
         if Bin0>0 and BTN(2) = '0' then Dec(0):=Dec(0)+1;
            Bin0:=Bin0-1;
            if Dec(0)=10 then Dec(0):=0; Dec(1):=Dec(1)+1;
               if Dec(1)=10 then Dec(1):=0; Dec(2):=Dec(2)+1;
                  if Dec(2)=10 then Dec(2):=0; Dec(3):=Dec(3)+1;
                     if Dec(3)=10 then Dec(3):=0; Dec(4):=Dec(4)+1;
                        if Dec(4)=10 then Dec(4):=0; Dec(5):=Dec(5)+1;
                           if Dec(5)=10 then Dec(5):=0; Dec(6):=Dec(6)+1;
                              if Dec(6)=10 then Dec(6):=0; Dec(7):=Dec(7)+1;
                                 if Dec(7)=10 then Dec(7):=0; Dec(8):=Dec(8)+1;
                                    if Dec(8)=10 then Dec(8):=0; Dec(9):=Dec(9)+1;
                                       if Dec(9)=10 then Dec(9):=0; Dec(10):=Dec(10)+1;
                                       end if;
                                    end if;
                                 end if;
                              end if;
                           end if;
                        end if;
                     end if;
                  end if;
               end if;
            end if;
            
         else 
         if BTN(2) = '0' then Dec_out:=Dec;Flag :=1;
         end if;
         Bin0:=0;
         --lcd2(98)<=Dec(9)+48;lcd2(99)<=Dec(8)+48;
            lcd_initial_32:=Lcd_initial(3 downto 2);
            lcd_initial_1:=Lcd_initial(1);
            lcd_initial_0:=Lcd_initial(0);
            lcd_initial_10:=Lcd_initial(1 downto 0);

            if Flag = 1 or BTN(2) = '1' then 
               Bin0:=Bin;
               Dec(9):=0;Dec(8):=0;
               Dec(7):=0;Dec(6):=0;Dec(5):=0;Dec(4):=0;Dec(3):=0;Dec(2):=0;Dec(1):=0;Dec(0):=0; 
               Flag := 0;
            end if;   
         end if;
         
         
         numerator_out:=numerator_in*vector(11 downto 0);
         if lcd_initial(3 downto 1)="000" then
            if lcd_initial(0)='1' then
               vector:=conv_std_logic_vector(Amp,12);
            else vector:=ramp_amp & '0';
            --Notice that the changed lcd data are in the first line lcd1 instead of lcd2
                     if SW(1) = '1' then lcd1(conv_integer(RampAmplitude & "0000")+8)<=O_Cp;lcd1(conv_integer(RampAmplitude & "0000")+9)<=N_Cp;lcd1(conv_integer(RampAmplitude & "0000")+10)<=Space; -- if I calculate the address from the 
                                                                                            -- lcd_initial here, it will take  173% of resource!!
                     else lcd1(conv_integer(RampAmplitude & "0000")+8)<=O_Cp;lcd1(conv_integer(RampAmplitude & "0000")+9)<=F_Cp;lcd1(conv_integer(RampAmplitude & "0000")+10)<=F_Cp; 
               end if;         
            end if;
               numerator_in:="000000000001010001100010110000";
                   lcd2(0)<=48+ramp_f_pointer; lcd2(1 to 5)<=(32,32,32,32,32);lcd2(6)<=32;Lcd2(7)<=Dec_out(5)+48;lcd2(8)<=46;lcd2(9)<=Dec_out(4)+48;lcd2(10)<=Dec_out(3)+48;lcd2(11)<=Dec_out(2)+48;
                  lcd2(12)<=Dec_out(1)+48;lcd2(13)<=Dec_out(0)+48;lcd2(14)<=V_Cp;lcd2(15)<=46;   
                  if numerator>4095 and BTN(2) = '0' then Volt0:=Volt0+1;numerator:=numerator-4096;
                  Else Bin:=Volt0;numerator:=numerator_out;
                     Volt0:=0;
                  end if;
--Step -> Frequency
         elsif lcd_initial="0010" then
               vector:=conv_std_logic_vector(Step,12);
               numerator_in:="111011100110101100101000000000";
                     lcd2(0 to 3)<=(32,32,32,32);lcd2(4)<=Dec_out(7)+48;lcd2(5)<=Dec_out(6)+48;lcd2(6)<=Dec_out(5)+48;lcd2(7)<=Dec_out(4)+48;lcd2(8)<=46;lcd2(9)<=Dec_out(3)+48;
                     lcd2(10)<=Dec_out(2)+48;lcd2(11)<=Dec_out(1)+48;lcd2(12)<=Dec_out(0)+48;lcd2(13)<=k;lcd2(14)<=H_Cp;lcd2(15)<=z;   
               if numerator>"0111111111111111" and BTN(2) = '0' then Volt0:=Volt0+1;numerator:=numerator-"1000000000000000";
               Else Bin:=Volt0;numerator:=numerator_out;
                  Volt0:=0;
               end if;
         elsif lcd_initial="0011" then
--Phase
               numerator_in:="00000000000" & conv_std_logic_vector(Phase,14) & "00000";
               vector:="110000110101";
                     lcd2(0 to 6)<=(S_Cp,h,i,f,t,32,32);lcd2(7)<=Dec_out(5)+48;lcd2(8)<=46;lcd2(9)<=Dec_out(4)+48;lcd2(10)<=Dec_out(3)+48;lcd2(11)<=Dec_out(2)+48;
                     lcd2(12)<=Dec_out(1)+48;lcd2(13)<=Dec_out(0)+48;lcd2(14)<=P_Cp;lcd2(15)<=i;   
               if numerator>8191 and BTN(2) = '0' then Volt0:=Volt0+1;numerator:=numerator-8192;
               Else Bin:=Volt0;numerator:=numerator_out;
                  Volt0:=0;
               end if;                                                                     
         
         elsif lcd_initial(3 downto 2)="10"  then
--Multiplier Gain
               case lcd_initial(1 downto 0) is
                  --when 72 =>   numerator_in:="000000000000000000"&Gain;vector:="000001000000"; 
                                                            -- 20091119 Deleted
                                                            -- 20091017 Changed from 1100 to 1001 to accommodate the extra power of 3-bits.
                                                            -- 20090927 changed from "0100" to "1100" so that there is an extra 512 gain.
                  when "00"=>   numerator_in:="00000000000000" & lockin_gain;vector:="001111101000";
                  when "01"=>   numerator_in:="00000000" & piezo_gain & "000000";vector:="001111101000"; ---Changed, to allow the display extra gain of 3-bit.!
                  when "10"=>   numerator_in:="00000000000000" & current_gain;vector:="001111101000";
                  when others =>
               end case;   
               
               lcd2(0 to 1)<=(32,32);
               lcd2(2)<=Dec_out(10)+48;lcd2(3)<=Dec_out(9)+48;
               lcd2(4)<=Dec_out(8)+48;lcd2(5)<=Dec_out(7)+48;lcd2(6)<=Dec_out(6)+48;
               lcd2(7)<=Dec_out(5)+48;lcd2(8)<=Dec_out(4)+48;lcd2(9)<=Dec_out(3)+48; 
               lcd2(10)<=46; lcd2(11)<=Dec_out(2)+48;lcd2(12)<=Dec_out(1)+48;
               lcd2(13)<=Dec_out(0)+48;lcd2(14)<=Space;lcd2(15)<=x; --bit int+14 saved for "k" in the case of multiplication gain.
               if numerator>63 and BTN(2) = '0' then Volt0:=Volt0+1;numerator:=numerator-64;
               Else Bin:=Volt0;numerator:=numerator_out;
                  Volt0:=0;
               end if;
--Filter Characteristic Frequency               
         elsif lcd_initial(3 DOWNTO 2)="01"  then
               case lcd_initial(1 downto 0) is
                  when "00"=> 
                     vector:=tau(11 downto 0); FIR_f_mux:=tau(13 downto 12);
                  when "01"=> 
                     vector:=tau_piezo(11 downto 0);FIR_f_mux:=tau_piezo(13 downto 12);
                  when "10"=> 
                     vector:=tau_Highpass(11 downto 0); FIR_f_mux:=tau_highpass(13 downto 12);
                  when "11"=> 
                     vector:=tau_current(11 downto 0);FIR_f_mux:=tau_current(13 downto 12);
                  when others=>
               end case;
                  
               case FIR_f_mux(1 downto 0) is
                  when "00"=>
                     numerator_in:="000000000000111010010010001100";
                     Unit:=k;   
                  when "11"=>
                     numerator_in:="000000001110001110101100010001";
                     Unit:=Space;
                  when "10"=>
                     numerator_in:="000011011110010101100011111000";
                     Unit:=m;                    
                  when "01"=>
                     numerator_in:="000000000011011110010101100011";
                     Unit:=m;
                  
                  when others=>
                     numerator_in:="000000000000000000000000000000";
               end case;
               lcd2(0 to 1)<=(f,q);
               lcd2(2 to 3)<=(32,32);
               lcd2(4)<=Dec_out(7)+48;
               lcd2(5)<=Dec_out(6)+48;lcd2(6)<=Dec_out(5)+48;lcd2(7)<=Dec_out(4)+48;
               lcd2(8)<=Dec_out(3)+48;lcd2(9)<=46;lcd2(10)<=Dec_out(2)+48;
               lcd2(11)<=Dec_out(1)+48;lcd2(12)<=Dec_out(0)+48; lcd2(13)<=Unit; lcd2(14)<=H_Cp;lcd2(15)<=z;   
               if numerator>0 and BTN(2) = '0' then Volt0:=Volt0+1;numerator:=numerator-1;
               Else 
                  Bin:=conv_integer(numerator_out(43 downto 12));
                  numerator:="000000000000000000000000000"& numerator_out(45 downto 27);--"000000000000000000000000000000"& tau(15 downto 0);--
                  Volt0:=0;
               end if;         
         end if;
      end if;
end process Display_conversion;

end Behavioral;

------------------------------------------------------------------------------------------------------------------------------------
--
-- END OF FILE Controller.vhd
--
------------------------------------------------------------------------------------------------------------------------------------

